//+------------------------------------------------------------------+
//|                                             VininI_LineStat2.mq4 |
//|                               Copyright  2010, Victor Nicolaev. |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Victor Nicolaev."
#property link      "vinin@mail.ru"


#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 2

extern int     BarsCount=15; //     ZZ
//  
double ZZ_1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init() {
   SetIndexBuffer(0, ZZ_1);      
               
   //     
   if (BarsCount<2) BarsCount=2;

   SetIndexStyle(0, DRAW_SECTION);   
   SetIndexLabel(0, "");

  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   static int dir=0, prevtime=0;
   int pos, i;
   
   
   // dir -  

   int counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars-1;
   
   if(counted_bars == 0) {
      limit=Bars-BarsCount-1;
      
   }
   
   for(i=limit; i>=0; i--) {
      ZZWork(ZZ_1, i);
   }   
   return(0);
}


void ZZWork(double &ZZ[], int pos){
   static int dir=0, ZZTime[2], pos1;
   int posHigh = iHighest( NULL, 0, MODE_HIGH, BarsCount, pos);   
   int posLow  = iLowest(  NULL, 0, MODE_LOW,  BarsCount, pos);
   ZZ[pos]=EMPTY_VALUE;
   if ((posHigh-pos)*(posLow-pos)==0) {
      int prevpos=iBarShift(NULL,0,ZZTime[0]);
      if (posHigh<posLow ) {
         if (dir==1) ZZ[prevpos]=EMPTY_VALUE; else {
            ZZTime[1]=ZZTime[0];
         }
         ZZ[pos]=High[pos];
         dir=1;
      } else {
         if (dir==-1) ZZ[prevpos]=EMPTY_VALUE;  else {
            
            ZZTime[1]=ZZTime[0];
         }
         ZZ[pos]=Low[pos];
         dir=-1;
      }
      ZZTime[0]=Time[pos];
   }
}